﻿; (function (window, undefined) {

    if (window.App === void 0) {
        throw new Error('/bridge/core.js must be included before you can use camera.js');
    }

    var App = window.App || {};

    function _takePicture(allowCropping, callback) {

        if (!callback) {
            throw new Error('You need to provide a valid callback');
        }

        App.execute('app/camera/takePicture', { 'allowCrop': allowCropping }, callback);
    }

    /**
     * The Camera module can be used to access the device camera.
     */
    var Camera = App.Camera = {

        /**
         * The current version of the Camera module.
         * @type {String}
         */
        VERSION: '2.0',

        /**
         * @public
         * Prompt the user to take a picture, and once complete the image will be returned using the callback as a base64 image.
         * @param  {Boolean}  Is cropping of the image allowed?
         * @param  {Function} The callback that should be invoked once the take image operation completes.
         * @throws {Error} If no valid callback has been specified.
         */
        takePicture: function (allowCropping, callback) {
            _takePicture(allowCropping, callback);
        },
    };

    App.Extend(Camera, App.Events);

})(window);